﻿package com.robotacid.engine_specific {
	import com.robotacid.engine.Dot;
	import com.robotacid.engine.HiddenInt;
	import com.robotacid.engine.Line;
	import flash.display.Graphics;
	import flash.display.Shape;
	
	/**
	* ...
	* @author Aaron Steed
	*/
	public class Gun extends Dot{
		
		public var g:Game;
		public var line:Line;
		public var health:HiddenInt;
		public var body:Shape;
		public var charge_shape:Shape;
		public var width:Number;
		public var charge:int;
		public var charge_alpha_step:Number;
		
		public static const CHARGE_DELAY:int = 50;
		public static const BULLET_SPEED:Number = 5;
		public static const START_HEALTH:int = 3;
		public static const MAX_HEALTH:int = 5;
		
		public function Gun(x:Number, y:Number, body:Shape, charge_shape:Shape, mouse:Dot, g:Game) {
			super(x, y);
			this.body = body;
			this.charge_shape = charge_shape;
			this.g = g;
			line = new Line(this, mouse);
			health = new HiddenInt(START_HEALTH);
			width = Game.WIDTH / 3;
			charge_alpha_step = 1 / CHARGE_DELAY;
			charge = CHARGE_DELAY;
		}
		public function main():void {
			body.x = charge_shape.x = x;
			body.y = charge_shape.y = y;
			if(charge < CHARGE_DELAY) {
				charge++;
				drawCharge();
			}
			// bullet firing
			if(g.mouse_pressed && charge >= CHARGE_DELAY){
				g.addBullet(x, y, line.dx, line.dy, BULLET_SPEED, true);
				charge = 0;
			}
		}
		public function drawBody():void {
			body.graphics.clear();
			body.graphics.lineStyle(0, 0, 0);
			
			// body
			body.graphics.beginFill(Game.FOREGROUND_COL);
			body.graphics.drawCircle(0, 0, 1 + health.value * 3);
			body.graphics.endFill();
			
			// catch nodes
			body.graphics.beginFill(Game.FOREGROUND_COL);
			body.graphics.drawCircle(-width * 0.5, 0, 1 + health.value);
			body.graphics.endFill();
			body.graphics.beginFill(Game.FOREGROUND_COL);
			body.graphics.drawCircle(width * 0.5, 0, 1 + health.value);
			body.graphics.endFill();
		}
		public function drawCharge():void {
			charge_shape.graphics.clear();
			charge_shape.graphics.lineStyle(2, Game.FOREGROUND_COL, charge_alpha_step * charge);
			charge_shape.graphics.drawCircle(0, 0, (health.value * 3) + CHARGE_DELAY - charge);
		}
		public function hit(x:Number):void {
			health.value--;
			if(health.value < 0) health.value = 0;
			drawBody();
			drawCharge();
		}
		
	}
	
}